"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WMLschematicMsgs = exports.i18nEnJSONFilePath = exports.FormsServiceFilePath = exports.DevEnvFile = exports.performDependencyInjection = exports.addImportStatements = exports.createStringObject = exports.getServiceClassVar = exports.getCpntClassVar = exports.camelCaseToSentence = exports.getFile = exports.findNodeTypeByRecursion = exports.FindNodeTypeByRecursionParams = exports.wmlFindChildNode = exports.prepareForUpdate = exports.addImportStatement = exports.getTsMemberInfo = exports.wmlMsgs = exports.getIndentation = exports.wmlCreateSourceFile = exports.removeLeadingWhitespace = void 0;
const ts = require("@schematics/angular/third_party/github.com/Microsoft/TypeScript/lib/typescript");
const schematics_1 = require("@angular-devkit/schematics");
const updateFile_1 = require("./updateFile");
const change_1 = require("@schematics/angular/utility/change");
const core_1 = require("@angular-devkit/core");
function removeLeadingWhitespace(inputString, prefixString, allowFirstLineUnshift = true) {
    var _a, _b, _c, _d;
    const lines = inputString.split('\n');
    if (allowFirstLineUnshift) {
        lines.shift();
    }
    if (lines.length === 0) {
        return inputString; // Nothing to process
    }
    let firstLineIndentation = (_b = (_a = RegExp(/^\s*/).exec(lines[0])) === null || _a === void 0 ? void 0 : _a[0]) !== null && _b !== void 0 ? _b : '';
    let prefixLineIndentation = (_d = (_c = RegExp(/^\s*/).exec(prefixString)) === null || _c === void 0 ? void 0 : _c[0]) !== null && _d !== void 0 ? _d : '';
    let result = lines.map(line => {
        let newLine = line
            .replace(firstLineIndentation, prefixLineIndentation)
            .replace(/_add_newline_here_/g, `\n${firstLineIndentation}`);
        return newLine;
    })
        .join('');
    return result;
}
exports.removeLeadingWhitespace = removeLeadingWhitespace;
function wmlCreateSourceFile(targetFilePath, tree) {
    let targetFile = tree.read(targetFilePath);
    if (!targetFile) {
        throw new schematics_1.SchematicsException(`This may be an internal issue but so far
    the ${targetFilePath} is not found so I cant selct the file to edit `);
    }
    return ts.createSourceFile(targetFilePath, targetFile.toString(), ts.ScriptTarget.Latest, true);
}
exports.wmlCreateSourceFile = wmlCreateSourceFile;
let getIndentation = (text = "") => {
    var _a;
    return (_a = RegExp(/\r?\n(\r?)\s*/).exec(text)) !== null && _a !== void 0 ? _a : [];
};
exports.getIndentation = getIndentation;
exports.wmlMsgs = {
    syntaxIssue: (addtl) => "I may have an internal error but I see that the syntax for this component class is incoorect  Fix the issue, " + addtl
};
function getTsMemberInfo(x) {
    console.log(x.getText(), x.kind);
}
exports.getTsMemberInfo = getTsMemberInfo;
let addImportStatement = (targetFilePath, tree, importStatementSnippet, packageName, importStatement, importMembers) => {
    let sourceFile = wmlCreateSourceFile(targetFilePath, tree);
    let statements = sourceFile.statements;
    let stmnt = statements.find((x) => {
        return x.getFullText().includes(packageName);
    });
    if (!stmnt) {
        importStatementSnippet += "\n" + importStatement;
    }
    else {
        let importClause = wmlFindChildNode(stmnt, ts.SyntaxKind.ImportClause, "its with the open brace of the import statement related to " + packageName);
        let namedImport = wmlFindChildNode(importClause, ts.SyntaxKind.NamedImports, "its with the open brace of the import statement related to " + packageName);
        let openBrace = wmlFindChildNode(namedImport, ts.SyntaxKind.OpenBraceToken, "its with the open brace of the import statement related to " + packageName);
        // SyntaxList
        let syntaxLists = namedImport.getChildren().find((x) => {
            return x.kind === ts.SyntaxKind.SyntaxList;
        })
            .getFullText()
            .split(",")
            .map((x) => {
            return x.trim();
        });
        let partialString = importMembers.filter((x) => {
            return !syntaxLists.includes(x.trim());
        }).join(",");
        partialString += partialString.length === 0 ? "" : " ,";
        prepareForUpdate(partialString, targetFilePath, tree, openBrace.end, "");
    }
    return importStatementSnippet;
};
exports.addImportStatement = addImportStatement;
function prepareForUpdate(snippet, targetFilePath, tree, insertPos = 0, indentTarget = "", spacingPrefix = "") {
    var _a;
    let final = "";
    let indentation = (0, exports.getIndentation)(indentTarget);
    snippet = removeLeadingWhitespace(snippet, indentTarget);
    final = `${spacingPrefix}${(_a = indentation[0]) !== null && _a !== void 0 ? _a : ' '}${snippet}`;
    let changes = [new change_1.InsertChange(targetFilePath, insertPos, final)];
    (0, updateFile_1.wmlUpdateFile)(tree, targetFilePath, changes);
}
exports.prepareForUpdate = prepareForUpdate;
function wmlFindChildNode(parent, syntaxKind, issueMsg = "There was an issue finding the node", printChildInfo = false, throwIfNotFound = true, findOrFilter = "find") {
    var _a, _b;
    // @ts-ignore
    let node = ((_b = (_a = parent === null || parent === void 0 ? void 0 : parent.getChildren) === null || _a === void 0 ? void 0 : _a.call(parent)) !== null && _b !== void 0 ? _b : parent)[findOrFilter](((x) => {
        if (printChildInfo) {
            getTsMemberInfo(x);
        }
        if (syntaxKind instanceof Function) {
            return syntaxKind(x);
        }
        else {
            return x.kind === syntaxKind;
        }
    }));
    if (!node && throwIfNotFound) {
        throw new schematics_1.SchematicsException(exports.wmlMsgs.syntaxIssue(issueMsg));
    }
    return node;
}
exports.wmlFindChildNode = wmlFindChildNode;
class FindNodeTypeByRecursionParams {
    constructor(params = {}) {
        this.printChildInfo = false;
        let origParams = Object.entries(params)
            .filter(([key]) => {
            return !key.startsWith('param');
        });
        Object.assign(this, Object.assign({}, Object.fromEntries(origParams)));
    }
}
exports.FindNodeTypeByRecursionParams = FindNodeTypeByRecursionParams;
function findNodeTypeByRecursion(params, level = 0) {
    const foundNodes = [];
    if (params.printChildInfo) {
        getTsMemberInfo(params.node);
        console.log("At level :", level);
    }
    if (params.kind instanceof Function) {
        if (params.kind(params.node, level)) {
            foundNodes.push(params.node);
        }
    }
    else if (params.node.kind === params.kind) {
        foundNodes.push(params.node);
    }
    // Recursively search in child nodes
    ts.forEachChild(params.node, (childNode) => {
        const childParams = Object.assign(Object.assign({}, params), { node: childNode });
        const childFoundNodes = findNodeTypeByRecursion(childParams, level + 1);
        foundNodes.push(...childFoundNodes);
    });
    return foundNodes;
}
exports.findNodeTypeByRecursion = findNodeTypeByRecursion;
function getFile(tree, path) {
    let targetPath = (0, core_1.normalize)(path);
    let targetFile = tree.read(targetPath);
    if (!targetFile) {
        console.log("fire");
        throw new schematics_1.SchematicsException(`${targetPath} not found`);
    }
    return { targetPath, targetFile };
}
exports.getFile = getFile;
function camelCaseToSentence(input) {
    // Use a regular expression to split the string based on capital letters
    const words = input.split(/(?=[A-Z])/);
    // Capitalize the first word and join the words into a sentence
    const sentence = words.map(word => word.charAt(0).toUpperCase() + word.slice(1)).join(' ');
    return sentence;
}
exports.camelCaseToSentence = camelCaseToSentence;
function getCpntClassVar(sourceFile) {
    return sourceFile.statements
        .filter(ts.isClassDeclaration)
        .find((v) => {
        var _a;
        return (_a = v.name) === null || _a === void 0 ? void 0 : _a.getText().endsWith("Component");
    });
}
exports.getCpntClassVar = getCpntClassVar;
function getServiceClassVar(sourceFile) {
    return sourceFile.statements
        .filter(ts.isClassDeclaration)
        .find((v) => {
        var _a;
        return (_a = v.name) === null || _a === void 0 ? void 0 : _a.getText().endsWith("Service");
    });
}
exports.getServiceClassVar = getServiceClassVar;
let createStringObject = (myStr, entitySuffix = "Component") => {
    if (!myStr) {
        throw new schematics_1.SchematicsException(" class name is missing or misspelt or the script is having issues finding the  class name");
    }
    let result = {
        orig: myStr,
        get prefix() {
            return this.orig.split(entitySuffix)[0];
        },
        camelCase: (stripSuffix = true, suffix = "") => {
            return schematics_1.strings.camelize(stripSuffix ? result.prefix : result.orig) + suffix;
        },
        classify: (stripSuffix = true, suffix = "") => {
            return schematics_1.strings.classify(stripSuffix ? result.prefix : result.orig) + suffix;
        },
        capitalize: (stripSuffix = true, suffix = "") => {
            return schematics_1.strings.capitalize(stripSuffix ? result.prefix : result.orig) + suffix;
        },
        dasherize: (stripSuffix = true, suffix = "") => {
            return schematics_1.strings.dasherize(stripSuffix ? result.prefix : result.orig) + suffix;
        },
        lowercase: (stripSuffix = true, suffix = "") => {
            return (stripSuffix ? result.prefix : result.orig).toLocaleLowerCase() + suffix;
        }
    };
    return result;
};
exports.createStringObject = createStringObject;
function addImportStatements(sourceFile, targetFilePath, tree, importsToAdd) {
    let importStatementSnippet = `\n`;
    sourceFile = wmlCreateSourceFile(targetFilePath, tree);
    let statements = sourceFile.statements
        .filter(ts.isImportDeclaration);
    for (const importData of importsToAdd) {
        importStatementSnippet = (0, exports.addImportStatement)(targetFilePath, tree, importStatementSnippet, importData.packageName, importData.importStatement, importData.importMembers);
    }
    sourceFile = wmlCreateSourceFile(targetFilePath, tree);
    statements = sourceFile.statements
        .filter(ts.isImportDeclaration);
    let lastMember = statements.at(-1);
    prepareForUpdate(importStatementSnippet, targetFilePath, tree, lastMember === null || lastMember === void 0 ? void 0 : lastMember.end, lastMember === null || lastMember === void 0 ? void 0 : lastMember.getFullText());
}
exports.addImportStatements = addImportStatements;
function performDependencyInjection(targetFilePath, tree, diString, classVar) {
    let constructor = wmlFindChildNode(classVar.members, ts.SyntaxKind.Constructor, "its with the constructor", false, false);
    if (!constructor) {
        let openBrace = wmlFindChildNode(classVar, ts.SyntaxKind.OpenBraceToken, "its with component class close {", false, false);
        if (openBrace.getFullText().includes(diString)) {
            return;
        }
        prepareForUpdate(` \n   constructor(
        ${diString}
      ) {}`, targetFilePath, tree, openBrace.end, classVar.getFullText());
    }
    else {
        if (constructor.getFullText().includes(diString)) {
            return;
        }
        let openParenToken = wmlFindChildNode(constructor, ts.SyntaxKind.OpenParenToken, "its with constuctor close parentheses", false, false);
        prepareForUpdate(`  ${diString},`, targetFilePath, tree, openParenToken.end, constructor.getFullText());
    }
}
exports.performDependencyInjection = performDependencyInjection;
exports.DevEnvFile = "src/environments/environment.dev.ts";
exports.FormsServiceFilePath = "src/app/shared/services/forms/forms.service.ts";
exports.i18nEnJSONFilePath = "src/assets/i18n/en.json";
exports.WMLschematicMsgs = {
    removePlacehoders0: "and for the beginners remember to remove the arrows as they are placeholders and dont belong in javascript!!"
};
//# sourceMappingURL=utils.js.map